/**
 * Utilities for versioning kind definitions
 */
library version;
import 'dart:mirrors';

import 'package:quiver/core.dart' as qcore;

import 'common.dart';

/**
 * Obtain a default serial version UID by hashing the
 * name and properties of the kind definition.
 */
int defaultSerialVersionUid(KindDefinition kindDefn) {
  var hashComponents = [kindDefn.name, kindDefn.extendsKind, kindDefn.concrete]
    ..addAll(kindDefn.properties.values);
  return qcore.hashObjects(hashComponents);
}

/**
 * Gets the value of the static final field
 * `serialVersionUID` from the class mirror.
 */
int _getSerialVersionUid(ClassMirror cls) {
  try {
    return cls.getField(#serialVersionUid).reflectee;
  } on NoSuchMethodError {


  }
}

KindDefinition _kindFromClassMirror(Datastore datastore, ClassMirror cls) {
  var kindName = cls.metadata.firstWhere((mdata) => mdata.reflectee is Kind).reflectee;
}
